Unit ALS1R4_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure ALS1R4(var A :Array of Real; M :Integer; N :Integer;
                var U :Array of Real);

implementation

procedure ALS1R4(var A :Array of Real; M :Integer; N :Integer;
                var U :Array of Real);
var
J,K,L :Integer;
H,R :Real;
const
ZERO :Real = 0.0;
label
_11,_12,_13,_14,_15;
begin
{ ****************************************************C }
{       V'*R=U' ,R     C }
{      D=Q*A*R ( ALS1R1).                  C }
{ ****************************************************C }
if ( N <= 2 ) or ( M < N ) 
 then goto _15;
J := N-1;
_11:
K := J-1;
if ( A[(K-1)+(J-1)*M] = ZERO ) 
 then goto _14;
R := ZERO;
for L:=J to N do
 begin
_12:
  R := R+A[(K-1)+(L-1)*M]*U[L-1];
 end;
if ( R = ZERO ) 
 then goto _14;
for L:=J to N do
 begin
_13:
  U[L-1] := U[L-1]-R*A[(K-1)+(L-1)*M];
 end;
_14:
J := K;
if ( J-1 ) < 0
 then goto _15
 else if ( J-1 ) > 0
       then goto _11
       else goto _15;
_15:
end;

end.
